> ## Documentation Index
> Fetch the complete documentation index at: https://docs.nx1cloud.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Source columns the draft doesn't return yet



## OpenAPI

````yaml get /api/data-apis/{name}/draft/source-columns
openapi: 3.1.0
info:
  title: Nx1 AI API
  description: |

    AI API for Nx1 Data Platform Management and Automated Data Tasks.

    Authentication is required via PSK in Authorization header.

    Default PSK is | [ask a friend] |
  version: 0.10.2
servers: []
security: []
paths:
  /api/data-apis/{name}/draft/source-columns:
    get:
      tags:
        - Data APIs
      summary: Source columns the draft doesn't return yet
      operationId: >-
        data_api_draft_source_columns_api_data_apis__name__draft_source_columns_get
      parameters:
        - name: name
          in: path
          required: true
          schema:
            type: string
            pattern: ^[a-z][a-z0-9_]{1,62}$
            description: The API's name.
            title: Name
          description: The API's name.
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/SourceColumnsResponse'
        '400':
          description: Invalid request.
        '403':
          description: Not allowed.
        '404':
          description: No such API or version.
        '409':
          description: Conflicts with the API's state.
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
        '429':
          description: Too many of your queries are running; see Retry-After.
      security:
        - OAuth2AuthorizationCodeBearer: []
        - APIKeyHeader: []
components:
  schemas:
    SourceColumnsResponse:
      properties:
        columns:
          items:
            $ref: '#/components/schemas/ContractColumn-Output'
          type: array
          title: Columns
      type: object
      required:
        - columns
      title: SourceColumnsResponse
      description: Columns the source has that the draft doesn't return (to add back).
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    ContractColumn-Output:
      properties:
        name:
          type: string
          title: Name
          description: Column name in the source.
        type:
          type: string
          title: Type
          description: Trino type, as the source reports it.
        description:
          type: string
          title: Description
          description: What the column means.
          default: ''
        business_name:
          anyOf:
            - type: string
            - type: 'null'
          title: Business Name
        nullable:
          type: boolean
          title: Nullable
          default: true
        is_key:
          type: boolean
          title: Is Key
          description: Part of the row's unique key (the grain).
          default: false
        filters:
          items:
            $ref: '#/components/schemas/api__models__data_api_models__FilterOp'
          type: array
          title: Filters
        sortable:
          type: boolean
          title: Sortable
          default: false
        glossary_terms:
          items:
            $ref: '#/components/schemas/api__models__data_api_models__GlossaryTermRef'
          type: array
          title: Glossary Terms
        tags:
          items:
            type: string
          type: array
          title: Tags
        sensitive:
          type: boolean
          title: Sensitive
          description: Carries a sensitive classification (PII, PHI, PCI, ...).
          default: false
        upstream:
          items:
            type: string
          type: array
          title: Upstream
          description: Source columns it is derived from (catalog.schema.table.column).
      type: object
      required:
        - name
        - type
      title: ContractColumn
      description: One column of a version's contract.
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
        input:
          title: Input
        ctx:
          type: object
          title: Context
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
    api__models__data_api_models__FilterOp:
      type: string
      enum:
        - eq
        - ne
        - in
        - gt
        - gte
        - lt
        - lte
        - is_null
      title: FilterOp
      description: A filter a column accepts, as ``?col.op=value`` (``eq`` is ``?col=``).
    api__models__data_api_models__GlossaryTermRef:
      properties:
        urn:
          type: string
          title: Urn
        name:
          type: string
          title: Name
        definition:
          anyOf:
            - type: string
            - type: 'null'
          title: Definition
      type: object
      required:
        - urn
        - name
      title: GlossaryTermRef
      description: A DataHub glossary term on a column.
  securitySchemes:
    OAuth2AuthorizationCodeBearer:
      type: oauth2
      flows:
        authorizationCode:
          scopes: {}
          authorizationUrl: >-
            https://sso-rapid.rapid.nx1cloud.com/realms/rapid/protocol/openid-connect/auth
          tokenUrl: >-
            https://sso-rapid.rapid.nx1cloud.com/realms/rapid/protocol/openid-connect/token
    APIKeyHeader:
      type: apiKey
      in: header
      name: Authorization-PSK

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.